//Admin Client
#include "AdminClient.h"

ApplicationClass Appl;
ApplicationClass* Application=&Appl;
static volatile int AuthPassed=0;
FILE* inp=NULL;
FILE* out=NULL;

void LOG(const char *fmt, ...){
	va_list va;
	va_start(va,fmt);
	char buff[256];
	vsprintf(buff,fmt,va);
	if(!inp){
		printf(buff);
	}else if(out){
		fprintf(out,buff);
	}
	va_end(va);
}


AdminClient::AdminClient(){
}

AdminClient::~AdminClient(){
}

//INTERFACE FUNCTIONS

void AdminClient::GuiPrint(char* message){
	LOG(message);
}

//process partner info loaded from server
void AdminClient::ProcessPartner(char*uname, int id, int ON_OFF, unsigned char* photo){
	LOG("Loaded partner: %s, ID=%d, ",uname,id);
	if(ON_OFF)
		LOG("online\n");
	else
		LOG("offline\n");
	int x;
	char BMPfile[100];
	strcpy(BMPfile,uname);
	strcat(BMPfile,"_photo.bmp");

	//Decode photo data
	BYTE*B=new BYTE[7500];
	int z=0;
	for(x=0;x<3750;x+=3){
		B[z++]=photo[x]&0xF0;
		B[z++]=(photo[x]&0x0F)<<4;
		B[z++]=photo[x+1]&0xF0;
		B[z++]=(photo[x+1]&0x0F)<<4;
		B[z++]=photo[x+2]&0xF0;
		B[z++]=(photo[x+2]&0x0F)<<4;
	}

	long s2;
	BYTE* c = ConvertRGBToBMPBuffer ( B, 50, 50, &s2 );
	if(!c){
		LOG("ERROR: ConvertRGBToBMPBuffer failed\n");
		delete[] B;
		return;
	}
	if(!SaveBMP ( c, 50, 50, s2, BMPfile )){
		LOG("BMP file could not be written\n");
	}

	delete[] B;
	delete[] c;
}

void AdminClient::NotifAuthPassed(){
	AdminPrintf("Authentication passed, route enabled\n");
	AuthPassed=1;
}

void AdminClient::NotifUserOffline(){
//nothing to implement here
}

void AdminClient::NotifUnameChg(int ID,char*name){
	AdminPrintf("NOTIF: user name changed\n");
	AdminPrintf("UNAMECHG: ID=%d,name=%s\n",ID,name);
}

void AdminClient::NotifUremoved(int ID){
	AdminPrintf("NOTIF: user removed: ID=%d\n",ID);
}

void AdminClient::NotifUstatus(int ID,int state){
	AdminPrintf("NOTIF: user status ID=%d ",ID);
	if(state)
		AdminPrintf("online\n");
	else
		AdminPrintf("offline\n");
}

//Route command from another client
void AdminClient::RouteNotifMsg(int From,int Font,char*message){
	AdminPrintf("ROUTE: from %d, MSG(F=%d)=%s\n",From,Font,message);
}

//Udate main panel GUI
void AdminClient::GuiUpdateNotif(){
	AdminPrintf("NOTIF: Udate main panel GUI\n");
}

void AdminClient::NetDisconnectNotif(){
	AdminPrintf("Network is disconnected\n");
}

void AdminClient::NotitErrorCode(int From,int ecode){
	char code[100];
	sprintf(code,"Error from Client=%d, code=%d\n",From,ecode);
	AdminPrintf(code);
}

//for test purposes only
void AdminClient::CRouteScriptCRCfailTest(int TOC){
	int n=20;
	recbuf[0]=0xBA;
	recbuf[1]=(n&0xFF00)>>8;
	recbuf[2]=n&0xFF;
	recbuf[4]=(i->ID&0xFF00)>>8;
	recbuf[5]=i->ID&0xFF;
	recbuf[6]=(TOC&0xFF00)>>8;
	recbuf[7]=TOC&0xFF;
	recbuf[8]=6;
	recbuf[9]=0;
	recbuf[10]=0;
	recbuf[11]=0;
	recbuf[12]=0;
	recbuf[13]=0;
	//false data
	recbuf[14]=0;
	recbuf[15]=0;
	recbuf[16]=0;
	recbuf[17]=0;
	recbuf[18]=0;
	recbuf[19]=0;
	//send
	recbuf[3]=0;
	recbuf[3]=Calculate_CRC8(recbuf,n);
	SendToServer(recbuf,n);
}

/*********************************************************************************/
int main(int argc, char* argv[]){
	if((argc>=2)&&!strcmp(argv[1],"remote")){
		char path[100];
		HINSTANCE hInstC = GetModuleHandle( 0 );
		GetModuleFileName(hInstC,path,99);
		AnsiString PATH=path;
		AnsiString filepath=ExtractFilePath(PATH);
		AnsiString _INP=filepath+"inp.txt";
		AnsiString _OUT=filepath+"out.txt";
		inp=fopen(_INP.String,"r");
		out=fopen(_OUT.String,"w");
		LOG("Remote mode\n");
	}

	AdminClient* ADM=new AdminClient();
	ADM->CreateClient();
	
	//Message loop
	char* buf=new char[4096];
	LOG("Message loop\n");
	char*c;
	int num;
	
	int timer=0;
	while(!AuthPassed&&(timer<20)){Sleep(1000);timer++;}
	
	while(inp?fgets(buf,4096,inp):gets(buf)){
		if(inp)LOG("%s",buf);
		ADM->FsendThGarbageColl();
		if(strlen(buf) == 0)
			break;
		if(ADM->ClientThreadRun==0)
			break;
		if(inp&&feof(inp))
			break;
		//Send routed keysync command
		if(c=strstr(buf,"csync")){
			c+=6;
			if(sscanf(c,"%d",&num)<1){
				LOG("Syntax error\n");
			}else{
				ADM->CRouteCmdKey(num,ADM->CSkey);
			}
		//Send route command
		}else if(c=strstr(buf,"route")){
			c+=6;
			if(sscanf(c,"%d",&num)<1){
				LOG("Syntax error\n");
			}else{
				c=strstr(buf,":");
				if(c){
					c++;
					ADM->CRouteScript(c, 0, num, ADM->CSkey);
				}else{
					LOG("Syntax error\n");
				}
			}
		//Send file to another client
		}else if(c=strstr(buf,"filesend")){
			c+=9;
			if(sscanf(c,"%d",&num)<1){
				LOG("Syntax error\n");
			}else{
				c=strstr(buf,":");
				if(c){
					c++;
					ADM->CRouteFileSend(num, c);//t kell majd irni h KEY-t is tadja session kezels miatt
				}else{
					LOG("Syntax error\n");
				}
			}
		//Send bad CRC failed client script - for test purposes
		}else if(c=strstr(buf,"crcfail")){
			c+=8;
			if(sscanf(c,"%d",&num)<1){
				LOG("Syntax error\n");
			}else{
				ADM->CRouteScriptCRCfailTest(num);
			}
		//Send resend request
		}else if(c=strstr(buf,"resend")){
			c+=7;
			if(sscanf(c,"%d",&num)<1){
				LOG("Syntax error\n");
			}else{
				ADM->CRouteError(num, 5);
			}
		}else if(c=strstr(buf,"wait")){
			c+=5;
			if(sscanf(c,"%d",&num)<1){
				LOG("Syntax error\n");
			}else{
				Sleep(num);
			}
		}else if(!ADM->AdminCmdInterp(buf)){
			LOG("ERROR: syntax error or sending failed!\n");
		}
	}
	delete[] buf;
	
	ADM->DestroyClient();
	delete ADM;
	if(inp){
		fclose(inp);
	}
	if(out){
		fclose(out);
	}
}
