//AnsiString Class
#include "AnsiString.h"

AnsiString::AnsiString(){
    String[0]=0;
}

AnsiString::AnsiString(const char* str){
    if(strlen(str)>=AnsiStringMAXLEN)
        ErrorAlert("ERROR: AnsiString too long! (1)","AnsiString::AnsiString");
    else
        strcpy(String,str);
}

AnsiString::~AnsiString(){
}

#ifndef LINUX
AnsiString::AnsiString(HWND Hwnd){
	Owner=Hwnd;
}
#endif

AnsiString AnsiString::operator=(const AnsiString &str){
    if(strlen(str.String)>=AnsiStringMAXLEN)
        ErrorAlert("ERROR: AnsiString too long! (2)","AnsiString::operator=(AnsiString)");
    else
        strcpy(String,str.String);
    return *this;
}

AnsiString AnsiString::operator=(const char * str){
    if(strlen(str)>=AnsiStringMAXLEN)
        ErrorAlert("ERROR: AnsiString too long! (3)","AnsiString::operator=(char*)");
    else
        strcpy(String,str);
    return *this;
}

AnsiString AnsiString::operator+(const AnsiString &str){
    AnsiString res;
    if(strlen(str.String)+strlen(String)>=AnsiStringMAXLEN)
        ErrorAlert("ERROR: Resulting AnsiString is too long!","AnsiString::operator+");
    else{
        strcpy(res.String,String);
        strcpy(res.String+strlen(res.String),str.String);
    }
    return res;
}


AnsiString AnsiString::operator+(const char * str){
    AnsiString res;
    if(strlen(str)+strlen(String)>=AnsiStringMAXLEN)
        ErrorAlert("ERROR: Resulting AnsiString is too long!","AnsiString::operator+");
    else{
        strcpy(res.String,String);
        strcpy(res.String+strlen(res.String),str);
    }
    return res;
}

char& AnsiString::operator[] (unsigned i){
    return String[i-1];
}

#ifndef LINUX
void AnsiString::Show(){
    MessageBox(Owner, String, TEXT("Message"), MB_APPLMODAL);
}

void AnsiString::ShowT(char* Title){
    MessageBox(Owner, String, Title, MB_APPLMODAL);
}

void AnsiString::ShowT(AnsiString Title){
    MessageBox(Owner, String, Title.String, MB_APPLMODAL);
}

void AnsiString::ShowErrorMsg(AnsiString Title){
    MessageBox(Owner, String, Title.String, MB_APPLMODAL | MB_ICONSTOP);
}
#endif

int AnsiString::AnsiCompare( const AnsiString & str){
    return strcmp(String,str.String);
}

int AnsiString::AnsiCompare( const char * str){
    return strcmp(String,str);
}

char* AnsiString::c_str(){
      return String;
}

int AnsiString::IsEmpty(){
    if(strlen(String))
        return 0;
    else 
        return 1;
}

int AnsiString::Length(){
    return strlen(String);
}

int AnsiString::Pos(const AnsiString & str){
    int x,van=0;
    int len1=strlen(String);
    int len2=strlen(str.String);
    
    for(x=0; x<=len1-len2 ;x++){
        if(!strncmp(&String[x],str.String,len2)){
            van=1;break;
        }
    }
    if(van){
        x++;
        return x;
    }else
        return 0;
}

int AnsiString::ConvertToInt(){
    char string[AnsiStringMAXLEN];
    strcpy(string,String);
    NumberConvError=0;
    
    int len =strlen(string);
    int szor=1;
    if(string[0]=='-'){szor=-1;string[0]='0';}
    int x;
    int num=0;
	
	if((string[0]=='0')&&(string[1]=='x')){
		for(x=2;x<len;x++){
			if((string[x]>='0')&&(string[x]<='9')){
				num=num+string[x]-'0';
				if(num<0){
					NumberConvError=1;
					return 0;              
				}
			}else if((string[x]>='A')&&(string[x]<='F')){
				num=num+string[x]-'A'+10;
				if(num<0){
					NumberConvError=1;
					return 0;              
				}				
			}else{
				NumberConvError=1;
				return 0;
			}
			if(x!=len-1)num*=16;
		}
		return num;
	}
	
    for(x=0;x<len;x++){
        if((string[x]>='0')&&(string[x]<='9')){
            num=num+string[x]-'0';
            if(num<0){
                NumberConvError=1;
                return 0;              
            }
        }else{
            NumberConvError=1;
            return 0;
        }
        if(x!=len-1)num*=10;
    }
    return szor*num;
}

double AnsiString::ConvertToDouble(){
    AnsiString S(String);
    NumberConvError=0;
    
    int egesz,tort;
    int x;
    int len =strlen(S.String);
    int point=len;
    for(x=0;x<len;x++)
        if(S.String[x]=='.')point=x;
    S.String[point]=0;    
    egesz=S.ConvertToInt();
    if(S.NumberConvError){NumberConvError=1;return 0.0;}
    
    tort=0;
    int w;
    double number;
    if(point!=len){
        char temp[AnsiStringMAXLEN];
        strcpy(temp,String);
        strcpy(S.String,&temp[point+1]);
        tort=S.ConvertToInt();
        if(S.NumberConvError){NumberConvError=1;return 0.0;}
        number=(double)tort;
        for(w=0;w<len-point-1;w++){
            number/=10.0;
        }
        if(egesz>=0)
            return (double)egesz+number;
        else
            return (double)egesz-number;
    }else{
        return (double)egesz;
    }
}

int AnsiString::ToInt(){
    int x=ConvertToInt();
    if(NumberConvError){
        throw NumberConvertException;
    }
    return x;
}

double AnsiString::ToDouble(){
    double x=ConvertToDouble();
    if(NumberConvError){
        throw NumberConvertException;
    }
    return x;
}

AnsiString AnsiString::Delete(int index, int count){
    char temp[AnsiStringMAXLEN];
    strcpy(temp,String);
    strcpy(&String[index-1],&temp[index-1+count]);
    return *this;
}

AnsiString AnsiString::Insert(const AnsiString& str, int index){
    if(strlen(str.String)+strlen(String)>=AnsiStringMAXLEN)
        ErrorAlert("ERROR: Resulting AnsiString is too long!","AnsiString::Insert");
    else{
        char temp[AnsiStringMAXLEN];
        strcpy(temp,String);
        strcpy(temp+index-1,str.String);
        strcpy(temp+index-1+strlen(str.String),String+index-1);
        strcpy(String,temp);
    }
    return *this;
}

int AnsiString::Pos(const char * str){
    AnsiString temp(str);
    return Pos(temp);
}

int AnsiString::AnsiPos(const char * str){
    AnsiString temp(str);
    return Pos(temp);
}

int AnsiString::AnsiPos(const AnsiString & str){
    return Pos(str);
}

AnsiString AnsiString::Insert(const char * str, int index){
    AnsiString temp(str);
    Insert(temp,index);
    return *this;
}

void AnsiString::IntToStr(int x){
    sprintf(String,"%d",x);
}

void AnsiString::FloatToStr(double x){
    sprintf(String,"%f",x);
}

AnsiString AnsiString::SubString (int index, int count){
    AnsiString res;
    strcpy(res.String,&String[index-1]);
    res.String[count]=0;
    return res;
}

void AnsiString::LoadStr(const char* str){
    if(strlen(str)>=AnsiStringMAXLEN)
        ErrorAlert("ERROR: AnsiString too long! (4)","AnsiString::LoadStr");
    else
        strcpy(String,str);
}

void AnsiString::LoadStr(const AnsiString &str){
    strcpy(String,str.String);
}

void AnsiString::UpperCase(){
	int x=0;
	while(String[x]){
		if((String[x]>='a')&&(String[x]<='z'))String[x]+=('A'-'a');
		x++;
	}
}

bool AnsiString::Load(char* fname){
	FILE*f;
	if(!( f=fopen(fname,"rb"))){
		ErrorAlert("ERROR: File open error!","AnsiString::Load");
		return false;
	}

	int x;
	for(x=0;x<AnsiStringMAXLEN;x++){
		String[x]=fgetc(f);
		if(feof(f))break;
		if(!String[x])break;
		if(String[x]==10)break;
		if(String[x]==13)break;
	}
	String[x]=0;
	
	fclose(f);
	return true;
}

bool AnsiString::Save(char* fname){
	FILE*f;
	if(!( f=fopen(fname,"wb"))){
		ErrorAlert("ERROR: File open error!","AnsiString::Save");
		return false;
	}
	int x;
	for(x=0;(x<AnsiStringMAXLEN)&&(x<strlen(String));x++){
		fputc(String[x],f);
	}
	fclose(f);
	return true;
}

bool AnsiString::SaveAdd(char* fname){
	FILE*f;
	if(!( f=fopen(fname,"ab"))){
		ErrorAlert("ERROR: File open error!","AnsiString::Save");
		return false;
	}
	int x;
	for(x=0;(x<AnsiStringMAXLEN)&&(x<strlen(String));x++){
		fputc(String[x],f);
	}
	fputc(13,f);
	fputc(10,f);
	fclose(f);
	return true;
}

bool AnsiString::Load(AnsiString &fname){
	return Load(fname.String);
}

bool AnsiString::Save(AnsiString &fname){
	return Save(fname.String);
}

bool AnsiString::SaveAdd(AnsiString &fname){
	return SaveAdd(fname.String);
}

#ifndef LINUX
void AnsiString::Sprintf(char*fmt,int n){
	sprintf(String,fmt,n);
}

void AnsiString::Sprintf(char*fmt,float n){
	sprintf(String,fmt,n);
}

void AnsiString::Sprintf(char*fmt,double n){
	sprintf(String,fmt,n);
}

void AnsiString::Sprintf(char*fmt,char* str){
	sprintf(String,fmt,str);
}

void AnsiString::Sprintf(char*fmt,AnsiString& str){
	sprintf(String,fmt,str);
}
#endif

int AnsiString::operator==(const AnsiString &str){
	if(strcmp(str.String,String))
		return 0;
	else
		return 1;
}

int AnsiString::operator==(const char * str){
	if(strcmp(str,String))
		return 0;
	else
		return 1;
}

int AnsiString::AnsiCompareIC( const AnsiString & str){
	AnsiString s(str);
	AnsiString z(String);
	s.LowerCase();
	z.LowerCase();
    return strcmp(s.String,z.String);
}

void AnsiString::LowerCase(){
	int x=0;
	while(String[x]){
		if((String[x]>='A')&&(String[x]<='Z'))String[x]-=('A'-'a');
		x++;
	}
}
