//Button Class

#include "ButtonClass.h"
extern int IDord;


Button::Button(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size):
Caption(this, &Button::GetCaption, &Button::SetCaption, &Button::GetRefCaption),
Enabled(this, &Button::GetEnabled, &Button::SetEnabled, &Button::GetRefEnabled)
{
    ButtonHwnd = CreateWindow(    "Button",
                                   Caption,
                                   BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE ,
                                   Size[0],Size[1],Size[2],Size[3],
                                   hwnd,(HMENU)IDord,
                                   hinst,
                                   0);

    ID=IDord++;
    
    CaptionText.LoadStr(Caption);
	hFont=NULL;
	
	ButtonProcAddr = (WNDPROC)GetWindowLong(ButtonHwnd, GWL_WNDPROC);
	SetWindowLong(ButtonHwnd, GWL_WNDPROC, reinterpret_cast<LONG_PTR>(&Button::StatWndProc));
}

Button::~Button(){
	//if(hFont)DeleteObject(hFont);
}


void Button::SetCaption(const AnsiString & str){
    CaptionText=str;
    SetWindowText(ButtonHwnd,CaptionText.c_str());
}

const AnsiString & Button::GetCaption()const{
    return CaptionText;
}

AnsiString & Button::GetRefCaption(){
    return CaptionText;
}

void Button::SetEnabled(const bool & en){
    EnabledState=en;
    EnableWindow(ButtonHwnd,EnabledState);
}

const bool & Button::GetEnabled() const{
    return EnabledState;
}

bool & Button::GetRefEnabled(){
    return EnabledState;
}

void Button::SetDefFont(){
	hFont = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Tahoma"));
	SendMessage(ButtonHwnd,WM_SETFONT ,(WPARAM)hFont,true);
}
