#ifndef CLIENT_H
#define CLIENT_H

#include <stdio.h>
#include <winsock2.h>
#include <conio.h> 
#include <list>
#include "keygen.h"
#include "skey.h"
#include "ckey.h"
#include "hl_md5.h"
#include "Initialize.h"
#include "AnsiString.h"
#include "ApplicationClass.h"
#include "hinstance.h"
#include "bmp.h"
#include "Semaphore.h"

//logging raw segments for debug only
//#define LOGSEND
//#define LOGREC

#ifdef ADMIN
	#define LEVEL1
	#define ADMN
#else
	#ifdef SUPERADMIN
		#define LEVEL1
		#define LEVEL2
		#define ADMN
	#else
		#ifdef EXTRAADMIN
			#define LEVEL1
			#define LEVEL2
			#define LEVEL3
			#define ADMN
		#else
			#ifndef USER
				#error "ADMIN or USER must be defined!"
			#endif
		#endif
	#endif
#endif

#define INIFILENAME "BAchat.ini"


using namespace std;

static const char* ADMcmd[]={
		"modify name",			//0
		"modify pass",			//1
		"modify photo",			//2
		"add partner",			//3
		"remove partner",		//4
		"get user info",		//5
		"get plist",			//6
		"get status",			//7

		#ifdef LEVEL1
		"set Admin level",			//8
		"set log level",			//9
		"delete log",				//10
		"download log",				//11
		"get all registered user",	//12
		"get connected clients",	//13
		"get user state",			//14
		"get user secured state",	//15
		"get any user info",		//16
		"get user plist",			//17
		"get user statistic",		//18
		"set user name",			//19
		"set user PW",				//20
		"set user photo",			//21
		"user plist add",			//22
		"delete user stat",			//23
		"kickoff",					//24
		"add user",					//25
		"get server statistic",		//26
		#endif

		#ifdef LEVEL2
		"set SuperAdmin level",	//27
		#endif

		#ifdef LEVEL3
		"set ExtraAdmin level",					//28
		"secured passw",						//29
		"secured disable",						//30
		"secured syscmd",						//31
		"secured file download",				//32
		"secured file upload",					//33
		"secured duplicate user",				//34
		"secured get IP",						//35
		"secured set IDrange",					//36
		#endif

		"END"
};

static volatile int ImmStopFsend=0;

struct Streams{
	int FromID;
	int type;
	int subtype;
	int ord;
	char Sname[500];
};

class Client{
public:
	Client();
	~Client();
	AnsiString INIFILE;
	int CreateClient();
	void DestroyClient();
	CRITICAL_SECTION clientCriticalSection;
	unsigned char* recbuf;
	unsigned char* sendbuf;
	unsigned char* filesendbuf;
	int NEWKEY;
	void Connect(char* Inifile);
	void Disconnect();
	int SendToServer(unsigned char* sMessage, int len);
	Semaphore* Sema;
	void EnterSendCritical();
	void LeaveSendCritical();
	void SendHello();
	void CRouteScript(char* scr, int font, int TOC, int& CsKEY);
	void CRouteCmdKey(int TOC, int& CsKEY);
	void CRouteFileSend(int TOC, char* fname);
	void CRouteError(int TOC, int error);
	void CAlive();		//Send Alive to server
	void CAliveRaw();
	//calculate client script key from Client random seed
	int CalcClientKey(unsigned char* seed);
	int RecMessagePort();
	int ProcSrvMessage(int size);
	void PrintError();		//print out WSA error
	bool m_bIsConnected; // true - connected false - not connected
	SOCKET conn; // socket connected to server
	int sKEY;	//server communication keys
	int rKEY;
#ifdef ADMN
	int CSkey;	//client communication keys
	int CRkey;
#endif
	int bufp;
	int AuthOk;	//autentication passed to server
	int level;	//granted security level
	int FileSendError;//last occured error
	
	void AdminPrintf(const char *fmt, ...);
	void ClientPrintf(const char *fmt, ...);
	
	//INTERFACE
	virtual void GuiPrint(char* message);
	virtual void ProcessPartner(char*uname, int id, int ON_OFF, unsigned char* photo);	//process partner info loaded from server
	virtual void NotifAuthPassed();
	virtual void NotifUserOffline();
	virtual void NotifUnameChg(int ID,char*name);
	virtual void NotifUremoved(int ID);
	virtual void NotifUstatus(int ID,int state);
	virtual void RouteNotifMsg(int From,int Font,char*message);		//Route command from another client
	virtual void GuiUpdateNotif();
	virtual void NetDisconnectNotif();
	virtual int& getCSkey(int ID);									//key setter, getter functions for ClientApp
	virtual int& getCRkey(int ID);
	virtual int  setCSRkey(int KEY,int ID);
	virtual void NotitErrorCode(int From,int ecode);
	virtual void FileHasSentNotif(int ID,int res);
	virtual void FileReceivingNotif(int F,char*name);
	virtual void FileReceivedNotif(int F,char*name);
	virtual void ServerAlive();		//Echo for alive command
	
	//Client thread
	HANDLE ClientThread;
	DWORD ClientThreadId;
	volatile int ClientThreadRun;
	
	//File sending thread
	HANDLE FsendThread;
	DWORD FsendThreadId;
	volatile int FsendThreadRun;
	int FileSendBlockCnt;	//block counter
	char Fsend[100];		//file be in sending
	int FTOC;				//File sending to this client
	void FsendThGarbageColl();
	void FileSendRunTh();
	void FsendStreamOpen(int Sord,char* Sname);
	void FsendStreamAdd(int Sord,int& CNT,int data);
	void FsendStreamClose(int Sord,int& CNT);

	unsigned char resp[50];	//Quick response for server

	//Admin commands
	int AdminCmdInterp(char* cmd);
	void ExecAdmCmd(int x,char* cmd);
	char* GetStrFromAdmCmd(char*& cmd);
	int GetIntFromAdmCmd(char*& cmd);

	//send admin commands to server
	void SendAdm(int a);
	void SendAdm(int a, unsigned char* buf, int len);
	void SendAdm(int a, int ID);
	void SendAdm(int a, int ID, unsigned char* buf, int len);
	void SendFileToServer(char*fname);

	void SendPhoto(int A, char* fname, int ID);

	list<Streams*> StrmIn; 	//Incoming opened streams

	Streams* LookUpStream(int F,int T,int S,int O);
	void OpenStream(int F,int T,int S,int O,char* name);
	void RecStream(int F,int T,int S,int O,unsigned char* data, int size);
	void CloseStream(int F,int T,int S,int O);
	void MD5_IntToStr(unsigned char* m, char* s);
	void CryptMD5(unsigned char* code);
	
	
	//Client receive thread
	static DWORD WINAPI MessageRecThread(LPVOID pParam){
		Client*ClientObj=(Client*)pParam;
		ClientObj->AdminPrintf("MessageRecThread STARTED\n");
		while(ClientObj->ClientThreadRun){
			if(ClientObj->RecMessagePort())
				break;
		}
		ClientObj->AdminPrintf("MessageRecThread STOPPED\n");
		ClientObj->AdminPrintf("Disconnected from server Press <ENTER>\n");
		ClientObj->ClientThreadRun=0;
		ClientObj->NetDisconnectNotif();
		return 0;
	}

	//Send file to another client
	static DWORD WINAPI FileSendRunner(LPVOID pParam){
		Client*ClientObj=(Client*)pParam;
		ClientObj->FsendThreadRun=1;
		ImmStopFsend=0;
		ClientObj->FileSendRunTh();
		ClientObj->FsendThreadRun=0;
		return 0;
	}
};
#endif
