//EditBox Class
#ifndef EditBoxClassH
#define EditBoxClassH

#include <windows.h>
#include "AnsiString.h"
#include "properties.h"

static WNDPROC EditProcAddr;

class EditBox{
  public:
    HWND EditBoxHwnd;
    AnsiString TextStr;
	HFONT hFont;
    int ID;
    EditBox(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size);
    ~EditBox();
    property<EditBox, AnsiString> Text;
    void SetText(const AnsiString & str);
    const AnsiString & GetText() const;
    AnsiString & GetRefText();
    void Clear();
	void ReadOnly(bool RO);
	void SetDefFont();
	HWND Handle();
	
    static LRESULT CALLBACK StatWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
		//char c;
		switch (Msg){
			case WM_KEYDOWN:	          //Keyboard
				SendMessage(GetParent(hWnd),WM_KEYDOWN,wParam,lParam);
				break;
     
			case WM_CHAR:                 //Keyboard char
				//c=(char)wParam;
				//if((c>='a')&&(c<='z'))break;
				//if((c>='A')&&(c<='Z'))break;
				//if((c>='0')&&(c<='9'))break;
				SendMessage(GetParent(hWnd),WM_CHAR,wParam,lParam);
				break;
				
			case WM_GETDLGCODE:
				if(wParam==VK_RETURN)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,13,0);
				if(wParam==VK_TAB)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_TAB,0);
				if(wParam==VK_ESCAPE)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_ESCAPE,0);
				break;
		}
		return CallWindowProc (EditProcAddr,hWnd, Msg, wParam, lParam);
    }

};
#endif
