//Form Base abstract class
#ifndef FormClassH
#define FormClassH

#include <windows.h>
#include "hinstance.h"

//WARNING!!! THESE TWO LINE ARE COPIED DIRECTLY FROM "resource.h" !!!
#define IDR_MENU1  100
#define IDI_ICON1  101

#define REGCALLBK(X) if(command==X->ID)

#define mrOk 		1
#define mrCancel 	2

class FormClass{
  public:
    char ChildOfMainForm;
	int STX;
	int STY;
	int WID;
	int HEI;
	HWND hwnd;               //This is the handle for our window
	bool Visible;
	HWND DialogHWND;
	HWND DialogOwner;
	int DialogResource;
    FormClass();
    virtual ~FormClass();
    void Create(char * AppName,int Wid,int Hei);
    void CreateHidden(char * AppName,int Wid,int Hei);
	void CreateSpecial(char * AppName,int StX,int StY,int Wid,int Hei,int Mode);
	void CreateDialogBox(HWND Owner,int Resource);
    void Show();
	int  ShowModal();
	void ModalResult(int result);
    void Hide();
	void Update();
	void Title(char* title);
	
    virtual void OnCommand(WORD command);
    virtual void OnKeyDown(WPARAM w);
	virtual void OnKeyUp(WPARAM w);
    virtual void OnChar(char ch);
    virtual void OnMouseButton(int X,int Y);
    virtual void OnMouseButtonUp(int X,int Y);
    virtual void OnMouseMove(int X,int Y);
    virtual void OnPaint();
    virtual void OnShow();
	virtual void OnMouseRightBtn(int X,int Y);
	virtual void OnMouseRightBtnUp(int X,int Y);
	virtual void OnMouseDbClick(int X,int Y);
	virtual void OnMouseWheel(int xPos,int yPos,WORD delta,WORD buttons);
	virtual void OnTimer(unsigned TimerID);
	virtual void Activate(int act);
	virtual void OnUserMessage(WPARAM wParam, LPARAM lParam);
	
	virtual void BuildForm(HWND Bhwnd,HINSTANCE BhInst);
	virtual void DestroyForm();
	
	virtual void ComboChange();
	virtual void OnAudioRecData();
	virtual void OnNotify(NMHDR*notif);
	virtual void Hscroll();
	virtual void Vscroll(DWORD s_info,DWORD s_handle);

	LRESULT WndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);
	BOOL CALLBACK DialogFunc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);
     
    static LRESULT CALLBACK InitialWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
        if (Msg == WM_NCCREATE) {
          LPCREATESTRUCT create_struct = reinterpret_cast<LPCREATESTRUCT>(lParam);
          void * lpCreateParam = create_struct->lpCreateParams;
          FormClass * this_window = reinterpret_cast<FormClass *>(lpCreateParam);
          SetWindowLongPtr(hWnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(this_window));
          SetWindowLongPtr(hWnd, GWLP_WNDPROC, reinterpret_cast<LONG_PTR>(&FormClass::StaticWndProc));
          return this_window->WndProc(hWnd, Msg, wParam, lParam);
        }
        return DefWindowProc(hWnd, Msg, wParam, lParam);
    }

    static LRESULT CALLBACK StaticWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
        LONG_PTR user_data = GetWindowLongPtr(hWnd, GWLP_USERDATA);
        FormClass * this_window = reinterpret_cast<FormClass *>(user_data);
        return this_window->WndProc(hWnd, Msg, wParam, lParam);
    }

    static BOOL CALLBACK InitialDialogFunc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {		
        LONG_PTR user_data = GetWindowLongPtr(hWnd, GWLP_USERDATA);
        FormClass * this_window = reinterpret_cast<FormClass *>(user_data);
		if(this_window)return this_window->DialogFunc(hWnd, Msg, wParam, lParam);
        if (Msg == WM_INITDIALOG) {
          FormClass * this_window = reinterpret_cast<FormClass *>(lParam);
		  this_window->DialogFunc(hWnd, Msg, wParam, lParam);
          SetWindowLongPtr(hWnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(this_window));
          return TRUE;
        }
		return FALSE;
    }
	
};

#endif
