//Admin Client
#include "BotChat.h"

ApplicationClass Appl;
ApplicationClass* Application=&Appl;

AdminClient* ACTHIS=NULL;
HANDLE TimerThread;
DWORD TimerThreadId;
int TimerThreadRun=0;
int AuthPassed;
int AliveCnt;

DWORD WINAPI TimerThreadFunc(LPVOID pParam){
	while(TimerThreadRun){
		Sleep(300);
		if(ACTHIS&&AuthPassed){
			if(AliveCnt==0){
				ACTHIS->CAlive();
			}
			AliveCnt++;
			if(AliveCnt>20)
				AliveCnt=0;
		}
	}
}

AdminClient::AdminClient(){
	ACTHIS=this;
	tmp=0;
	AuthPassed=0;
	AliveCnt=-80;
	
	//create timer thread
	TimerThreadRun=1;
	TimerThread=CreateThread(NULL, 0, TimerThreadFunc, 0, 0, &TimerThreadId);
	if(TimerThread==NULL){
		printf("Failed to create timer thread\n");
	}
}

AdminClient::~AdminClient(){
	list<Questioner*>::iterator itl;
	for(itl = QC.begin();itl != QC.end();itl++){
		delete *itl;
	}
	QC.clear();
	
	//closing timer thread
	TimerThreadRun=0;
	printf("Waiting for Timer Thread to be terminated\n");
	WaitForMultipleObjects(1, &TimerThread, TRUE, 2000);
	printf("Closing Timer Thread\n");
	if(!CloseHandle(TimerThread)){
		printf("ERROR closing TimerThread\n");
	}
}

//INTERFACE FUNCTIONS

void AdminClient::GuiPrint(char* message){
	printf("%s",message);
}

//process partner info loaded from server
void AdminClient::ProcessPartner(char*uname, int id, int ON_OFF, unsigned char* photo){
	printf("Loaded partner: %s, ID=%d, ",uname,id);
	if(ON_OFF)
		printf("online\n");
	else
		printf("offline\n");
}

void AdminClient::NotifAuthPassed(){
	printf("Authentication passed, route enabled\n");
	AuthPassed=1;
}

void AdminClient::NotifUstatus(int ID,int state){
	printf("NOTIF: user status ID=%d ",ID);
	if(state){
		printf("online\n");
	}else{
		printf("offline\n");
		Questioner*Q = LookUpClient(ID);
		if(Q==NULL)
			return;
		QC.remove(Q);
		delete Q;
	}
}

//Route command from another client
void AdminClient::RouteNotifMsg(int From,int Font,char*message){
	printf("%d-> %s\n",From,message);
	FILE*f=fopen(LOGFILE,"a+");
	if(f==NULL){
		printf("LOG file open ERROR\n");
		return;
	}
	fprintf(f,"%d-> %s\n",From,message);
	fclose(f);
	Questioner*Q = LookUpClient(From);
	if(Q==NULL){
		return;
	}
	CRouteScript("Ksznjk a megjegyzst, szrevtelt,\ndvzlettel: a fejleszt, Bognr Andrs", 0, From, Q->skey);
}

void AdminClient::NetDisconnectNotif(){
	printf("Network is disconnected\n");
	AuthPassed=0;
}

void AdminClient::NotitErrorCode(int ecode){
	char code[100];
	sprintf(code,"Error from client, code=%d\n",ecode);
	printf("%s",code);
}

int& AdminClient::getCSkey(int ID){
	Questioner*Q = LookUpClient(ID);
	if(Q==NULL){
		return tmp;
	}
	return Q->skey;
}

int& AdminClient::getCRkey(int ID){
	Questioner*Q = LookUpClient(ID);
	if(Q==NULL){
		return tmp;
	}
	return Q->rkey;
}

int  AdminClient::setCSRkey(int KEY,int ID){
	Questioner*Q = LookUpClient(ID);
	if(Q==NULL){
		Q=new Questioner();
		Q->ID=ID;
		Q->skey=KEY;
		Q->rkey=KEY;
		QC.push_back(Q);
	}else{
		Q->skey=KEY;
		Q->rkey=KEY;
	}
	return KEY;
}

void AdminClient::FileReceivingNotif(int F,char*name){
}

void AdminClient::FileReceivedNotif(int F,char*name){
	Questioner*Q = LookUpClient(F);
	if(Q==NULL){
		return;
	}
	CRouteScript("Kszi a fjlt\n", 0, F, Q->skey);
}

Questioner* AdminClient::LookUpClient(int id){
	list<Questioner*>::iterator itl;
	for(itl = QC.begin();itl != QC.end();itl++){
		if( (*itl)->ID == id )
			return *itl;
	}
	return NULL;
}

/*********************************************************************************/
int main(int argc, char* argv[]){
	//enter
	AdminClient* ADM=new AdminClient();
	ADM->CreateClient();
	
	//Message loop
	char* buf=new char[100];
	printf("Message loop\n");
	//char*c;
	//int num;
	while(gets(buf)){
	/*
		ADM->FsendThGarbageColl();
	*/
		if(strlen(buf) == 0)
			break;
	/*
		if(ADM->ClientThreadRun==0)
			break;
		//Send routed keysync command
		if(c=strstr(buf,"csync")){
			c+=6;
			if(sscanf(c,"%d",&num)<1){
				printf("Syntax error\n");
			}else{
				ADM->CRouteCmdKey(num,ADM->CSkey);
			}
		//Send route command
		}else if(c=strstr(buf,"route")){
			c+=6;
			if(sscanf(c,"%d",&num)<1){
				printf("Syntax error\n");
			}else{
				c=strstr(buf,":");
				if(c){
					c++;
					ADM->CRouteScript(c, 0, num, ADM->CSkey);
				}else{
					printf("Syntax error\n");
				}
			}
		//Send file to another client
		}else if(c=strstr(buf,"filesend")){
			c+=9;
			if(sscanf(c,"%d",&num)<1){
				printf("Syntax error\n");
			}else{
				c=strstr(buf,":");
				if(c){
					c++;
					ADM->CRouteFileSend(num, c);//t kell majd irni h KEY-t is tadja session kezels miatt
				}else{
					printf("Syntax error\n");
				}
			}
		}else if(!ADM->AdminCmdInterp(buf)){
			printf("ERROR: syntax error or sending failed!\n");
		}
		*/
	}
	delete[] buf;

	//exit
	ADM->DestroyClient();
	delete ADM;
}
