//Initializable variables
//These variables are initialized from INI file
#include <stdio.h>
#include <string.h>
#include "Inifile.h"

Initializable*i=NULL;


//convert MD5 code from integer array to string
void MD5_IntToStr(unsigned char* m, char* s){
	int x;
	int w;
	for(x=0;x<16;x++){
		for(w=0;w<2;w++){
			switch( w? m[x]&0x0F : (m[x]&0xF0)>>4 ){
				case 0:
					s[x*2+w]='0';
					break;
				case 1:
					s[x*2+w]='1';
					break;
				case 2:
					s[x*2+w]='2';
					break;
				case 3:
					s[x*2+w]='3';
					break;
				case 4:
					s[x*2+w]='4';
					break;
				case 5:
					s[x*2+w]='5';
					break;
				case 6:
					s[x*2+w]='6';
					break;
				case 7:
					s[x*2+w]='7';
					break;
				case 8:
					s[x*2+w]='8';
					break;
				case 9:
					s[x*2+w]='9';
					break;
				case 10:
					s[x*2+w]='A';
					break;
				case 11:
					s[x*2+w]='B';
					break;
				case 12:
					s[x*2+w]='C';
					break;
				case 13:
					s[x*2+w]='D';
					break;
				case 14:
					s[x*2+w]='E';
					break;
				case 15:
					s[x*2+w]='F';
					break;
			}
		}
	}
	s[32]=0;
}

//convert MD5 code from string to integer array
void MD5_StrToInt(char* s, unsigned char* m){
	int x;
	int w;
	for(x=0;x<16;x++){
		m[x]=0;
		for(w=0;w<2;w++){
			switch( s[x*2+w] ){
				case '0':
					break;
				case '1':
					m[x]|=!w?0x10:0x01;
					break;
				case '2':
					m[x]|=!w?0x20:0x02;
					break;
				case '3':
					m[x]|=!w?0x30:0x03;
					break;
				case '4':
					m[x]|=!w?0x40:0x04;
					break;
				case '5':
					m[x]|=!w?0x50:0x05;
					break;
				case '6':
					m[x]|=!w?0x60:0x06;
					break;
				case '7':
					m[x]|=!w?0x70:0x07;
					break;
				case '8':
					m[x]|=!w?0x80:0x08;
					break;
				case '9':
					m[x]|=!w?0x90:0x09;
					break;
				case 'A':
					m[x]|=!w?0xA0:0x0A;
					break;
				case 'B':
					m[x]|=!w?0xB0:0x0B;
					break;
				case 'C':
					m[x]|=!w?0xC0:0x0C;
					break;
				case 'D':
					m[x]|=!w?0xD0:0x0D;
					break;
				case 'E':
					m[x]|=!w?0xE0:0x0E;
					break;
				case 'F':
					m[x]|=!w?0xF0:0x0F;
					break;
			}
		}
	}
}

void MD5cry(){
	unsigned char PASSMD5_scry[16]={0xAB,0xEB,0xC3,0x7A,0x91,0xAF,0x4E,0x12,0x82,0xE4,0x22,0x5A,0xF2,0xC7,0xB9,0xE9};
	int x;
	if(i==NULL)
		return;
	for(x=0;x<16;x++)
		i->Upass[x]=i->Upass[x]^PASSMD5_scry[x];
}

int LoadFromIni(char*inifile){
	char*c;
	char*u;
	int x;
	char buf[105];
	
	if(i==NULL)
		return 1;
	
	//Load INI file
	FILE *fp = fopen(inifile,"r");
	if(fp == NULL){
		//printf("Unable to open Inifile\n");
		return 1;
	}
	//get Font
	if(fgets(buf,100,fp) == NULL){
		return 1;
	}else{
		if(strstr(buf,"Font=")==NULL){
			return 1;
		}
	}
	u=c=strstr(buf,"=")+1;
	while( (*c!=10)&&(*c!=13)&&(*c!=0) )c++;
	*c=0;
	if(sscanf(u,"%d",&(i->EditFont))<1){
		//printf("ERROR in INI file FONT is not a number\n");
		return 1;
	}
	//get Frame
	if(fgets(buf,100,fp) == NULL){
		return 1;
	}else{
		if(strstr(buf,"Frame=")==NULL){
			return 1;
		}
	}
	u=c=strstr(buf,"=")+1;
	while( (*c!=10)&&(*c!=13)&&(*c!=0) )c++;
	*c=0;
	if(sscanf(u,"%d",&i->ActFrame)<1){
		//printf("ERROR in INI file FRAME is not a number\n");
		return 1;
	}
	//get IP
	if(fgets(buf,100,fp) == NULL){
		return 1;
	}else{
		if(strstr(buf,"IP=")==NULL){
			return 1;
		}
	}
	u=c=strstr(buf,"=")+1;
	while( (*c!=10)&&(*c!=13)&&(*c!=0) )c++;
	*c=0;
	strcpy(i->sIpAddress,u);
	//printf("server IP=%s\n",sIpAddress);
	//get PORT
	if(fgets(buf,100,fp) == NULL){
		return 1;
	}else{
		if(strstr(buf,"PORT=")==NULL){
			return 1;
		}
	}
	u=c=strstr(buf,"=")+1;
	while( (*c!=10)&&(*c!=13)&&(*c!=0) )c++;
	*c=0;
	if(sscanf(u,"%d",&i->iPort)<1){
		//printf("ERROR in INI file PORT is not a number\n");
		i->iPort=8084;
	}
	//printf("PORT=%d\n",iPort);
	//get ID
	if(fgets(buf,100,fp) == NULL){
		return 1;
	}else{
		if(strstr(buf,"ID=")==NULL){
			return 1;
		}
	}
	u=c=strstr(buf,"=")+1;
	while( (*c!=10)&&(*c!=13)&&(*c!=0) )c++;
	*c=0;
	if(sscanf(u,"%d",&i->ID)<1){
		//printf("ERROR in INI file ID is not a number\n");
		return 1;
	}
	//printf("ID=%d\n",ID);
	//get NAME
	if(fgets(buf,100,fp) == NULL){
		return 1;
	}else{
		if(strstr(buf,"NAME=")==NULL){
			return 1;
		}
	}
	u=c=strstr(buf,"=")+1;
	while( (*c!=10)&&(*c!=13)&&(*c!=0) )c++;
	*c=0;
	if(strlen(u)>20){
		//printf("ERROR: NAME is invalid \n");
		return 1;
	}
	strcpy(i->Uname,u);
	for(x=strlen(i->Uname);x<21;x++)
		i->Uname[x]=0;
	//printf("NAME=%s\n",Uname);
	//PW
	if(fgets(buf,100,fp) == NULL){
		return 1;
	}else{
		if(strstr(buf,"PW=")==NULL){
			return 1;
		}
	}
	u=c=strstr(buf,"=")+1;
	while( (*c!=10)&&(*c!=13)&&(*c!=0) )c++;
	*c=0;
	MD5_StrToInt(u,i->Upass);
	MD5cry();
	
	fclose(fp);
	
	return 0;
}

int SaveToIni(char*inifile){
	if(i==NULL)
		return 1;
		
	FILE *fp = fopen(inifile,"w");
	
	fprintf(fp,"Font=%d\n",i->EditFont);
	fprintf(fp,"Frame=%d\n",i->ActFrame);
	fprintf(fp,"IP=%s\n",i->sIpAddress);
	fprintf(fp,"PORT=%d\n",i->iPort);
	fprintf(fp,"ID=%d\n",i->ID);
	fprintf(fp,"NAME=%s\n",i->Uname);
	MD5cry();
	char buff[40];
	MD5_IntToStr(i->Upass, buff);
	fprintf(fp,"PW=%s\n",buff);
	MD5cry();
	
	fclose(fp);
	return 0;
}
