#!/bin/sh
#System V init script for:
#LongPolling service for real time forums. PHP helper (dyndns.hu)
#Created by Andras Bognar 2014

. /lib/lsb/init-functions

case $1 in
	start)
		echo "Starting LongPoll service"
		exec /bin/bamessenger/longpolld/lpolld
	;;
	stop)
		echo "Stopping LongPoll service"
		PID=$(cat /bin/bamessenger/longpolld/lpoll.lock)
		kill $PID
	;;
	restart)
		echo "Restarting LongPoll service"
		PID=$(cat /bin/bamessenger/longpolld/lpoll.lock)
		kill -HUP $PID
	;;
	status)
		echo "Status of LongPoll service:"
		if [ -f /bin/bamessenger/longpolld/lpoll.lock ]; then
			PID=$(cat /bin/bamessenger/longpolld/lpoll.lock)
			if ! kill -0 $PID > /dev/null 2>&1; then
				echo "LongPoll service is not running"
			else
				echo "LongPoll service is RUNNING, PID="$PID
			fi
		else
			echo "LongPoll service is not running"
		fi
	;;
	*)
		echo "ERROR invalid command"
		exit 1
	;;
esac 
