#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <termios.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include <list>
#include <vector>
#include <stdarg.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "../keygen.h"
#include "../skey.h"


//if this defined then the server is compiled as Linux daemon otherwise compiled as an application
#define SERVICEMODE

#define INIFILE "server.ini"
static int PORT=443;
//Userlist file location loaded at startup
static char USERLIST[100]={"CL.dat"};
//place to log into, logging enabled when LOG_CONSOLE is not defined
static char LOG_FILE[100]={"serverlog.log"};
//secured log
static char SECLOG[100]={"serverlog.dat"};
//checkIDrange() uses it, accessing of users with admins below this ID limit
static int ID_range_min=5;
//logging level defult settings
static volatile int LogLevel=3;

//if this defined than the log is printed to the console else printed to LOG_FILE
#define LOG_CONSOLE
//Logging sent segment to client
//#define LOGsend
//Logging received segments(raw)
//#define LOGRawrec
//Logging received messages
//#define LOGrec
//Routing command is not sent back to the sender (FROM==TO loopback is not enabled)
#define NOSELFROUTE

//LOG message levels
//error message type
#define ERR 1
//connection status change type
#define CON 2
//informal type
#define INF 3

#ifdef SERVICEMODE
	#ifdef LOG_CONSOLE
		#undef LOG_CONSOLE
	#endif
	#define RUNNING_DIR	"/bin/bamessenger"
    #define LOCK_FILE	"bam.lock"
#endif

using namespace std;

typedef unsigned char BYTE;
typedef int SOCKET;
#define INVALID_SOCKET -1

static int ClientIDcnt=1;	//for ordering clients
struct Client{
	int ID;
	SOCKET sock;
	pthread_t thread;
	volatile int ThRun;
	
	volatile int state;		//autentication state
	int bufp;		//fragment buffer pointer
	volatile int stimer;		//state timer, stucked state timeout counter
	unsigned char* recbuf;	//buffer used for to receive
	unsigned char* autkey;	//buffer used for to autentication
	int sKEY;		//server script send key
	int rKEY;		//server script receive key
	int ecnt;		//error counter
	int acnt;		//alive counter - checking alive, autokickoff
};

//registered users
struct User{
	char name[21];
	unsigned char PW[16];	//MD5 hash
	int ID;
	unsigned char* photo;
	vector<int> Plist;
	Client* c;
	//statistic
	unsigned int UstatConn;
	unsigned int UstatSent;
	unsigned int SumErrors;
};


class CServer{
public:
	CServer();
	~CServer();
	void Create();
	void Destroy();
	void StartListenClient(); // Listen to client
	void SendToClient(Client*c,unsigned char* sMessage, int len);	// Send message to a selected client.
	void SendNotif(Client*c, int Notif);		//Send notification to client
	void SendError(Client*c, int Ecode);		//Send error to client
	void SendUserInfo(Client*c, int CID, int id, int GUIupdate);		//Send user info to client
	void SendBackCAlive(Client*c);				//send back Alive 
	void ProcClMessage(Client*c, int size);		//process message from client
	
	int RecClient(Client*c); // receive message for a particulat socket
	//void PrintError();		//print out WSA error
	//void PrintError(int dw);//print out WSA error code
	void RemoveClient(Client*c);
	bool m_bIsConnected; // true - connected false - not connected
	
	int LoadUserList();	//Load crypted user list to hash table
	int SaveUserList();//Save crypted user list from hash table
	int CheckDatabaseConsistence();
	int AddUser(char*Uname, unsigned char* Upass);//Add user to database
	int GetULcryToBuf(unsigned char* buf, int len, int& KEY, FILE*f);
	void FlushBufToULcry(unsigned char* buf, int len, int& KEY, FILE*f);
	
	//Server thread
	pthread_t ServerThread;
	volatile int ServerThreadRun;
	
	//Timer thread
	pthread_t TimerThread;
	volatile int TimerThreadRun;

	list<Client*> m_vClientList; 	// All socket connected to client, and active
	list<Client*> zombieClientList; // All deleted client, but threads of them are not closed
	list<Client*> unusedClientList; // All deleted unused client objects (wait for recycling)
	list<Client*> timesupervisClient;// All Clients to be supervised, response requested in certain time slot, exceeding it socket will be closed
	SOCKET m_SListenClient; // socket listening for client calls
	
	vector<User*> Users;			//All registered users
	int secured;			//secured requests are enabled or not
	FILE* up;				//File pointer used to upload files to server
	//ID=0 : disable logging ID=3 : delete log file	ID=4 : log all	ID=X : log X only
	volatile int ID_sup;				//Logging, supervising this ID.
	
	//Convert MD5 string to integer array and back
	void MD5_IntToStr(unsigned char* m, char* s);
	void MD5_StrToInt(char* s, unsigned char* m);

	//Create: Assemble more complicated notifications
	void CreateNotif(Client*c,int size);
	//Send: Assemble more complicated notifications
	void SendCreatedNotif(Client*c);
	//user name changed (UNAMECHG)
	void Send_UNAMECHG(Client*c,int id,char*name);
	//user is removed from Plist (UREMOVE)
	void Send_UREMOVE(Client*c,int id);
	//user status changed (on/offl.) (USTATUS)
	void Send_USTATUS(Client*c,int id, int st);
	void Broadcast_USTATUS(Client*c, int st);
	//user added successfully (ADDEDSUCCESS)
	void Send_ADDEDSUCCESS(Client*c,int id);
	//Security level granted (SECGRANT)
	void Send_SECGRANT(Client*c,int level);
	//GETUSTATUID
	void Send_GETUSTATUID(Client*c);
	//GETUSECUSTAT
	void Send_GETUSECUSTAT(Client*c);
	//GETUPLUID
	void Send_GETUPLUID(Client*c);
	//GETUSUID
	void Send_GETUSUID(Client*c);
	//GETSERST
	void Send_GETSERST(Client*c);

	int LookupID(char*name);
	int checkIDrange(int id);

	//Check Admin autentication level
	int CheckLevel2();
	int CheckLevel3();
	//remove partner from user partner list
	void RemovePfromUser(int U, int P);

	void DownloadLog(Client*c);
	void DownloadFile(Client*c,char* fname);
	
	void StreamOpen(Client*c,int Sord,char* Sname);
	void StreamAdd(Client*c,int Sord,int& CNT,int data);
	void StreamClose(Client*c,int Sord,int& CNT);
	void DownloadUsers(int x,Client*c);
	void SendSpecUserInfo(Client*c,int X,int UID);
	void GetSecuredIP(Client*c,int UID);
};
