#!/bin/sh
#Bognar Messenger daemon
#Created by Andras Bognar 2014

. /lib/lsb/init-functions

case $1 in
        start)
                echo "Starting Bognar Messenger"
                /bin/bamessenger/BAmsgd
                echo "Waiting 10sec for server startup"
                sleep 10
                echo "Starting bots: ElisaBot Hibabejelento"
                /bin/bamessenger/elisabot/ElisaBot
                /bin/bamessenger/hibabej/Hibabejelento
        ;;
        stop)
                echo "Stopping Bognar Messenger"
                PID=$(cat /bin/bamessenger/bam.lock)
                kill $PID
        ;;
        status)
                echo "Status of Bognar Messenger server:"
                if [ -e /bin/bamessenger/bam.lock ]; then
                        if [ -r /bin/bamessenger/bam.lock ]; then
                                PID=$(cat /bin/bamessenger/bam.lock)
                                if ! kill -0 $PID > /dev/null 2>&1; then
                                        echo "BA Messenger is not running (No process with PID)"
                                else
                                        echo "BA Messenger is RUNNING, PID="$PID
                                fi
                        else
                                echo "No permission to read status"
                        fi
                else
                        echo "BA Messenger is not running (No lock file)"
                fi
                echo "Status of Elisabot client:"
                if [ -e /bin/bamessenger/elisabot/bame.lock ]; then
                        if [ -r /bin/bamessenger/elisabot/bame.lock ]; then
                                PID=$(cat /bin/bamessenger/elisabot/bame.lock)
                                if ! kill -0 $PID > /dev/null 2>&1; then
                                        echo "Elisabot is not running (No process with PID)"
                                else
                                        echo "Elisabot is RUNNING, PID="$PID
                                fi
                        else
                                echo "No permission to read status"
                        fi
                else
                        echo "Elisabot is not running (No lock file)"
                fi
                echo "Status of Hibabejelento client:"
                if [ -e /bin/bamessenger/hibabej/bamh.lock ]; then
                        if [ -r /bin/bamessenger/hibabej/bamh.lock ]; then
                                PID=$(cat /bin/bamessenger/hibabej/bamh.lock)
                                if ! kill -0 $PID > /dev/null 2>&1; then
                                        echo "Hibabejelento is not running (No process with PID)"
                                else
                                        echo "Hibabejelento is RUNNING, PID="$PID
                                fi
                        else
                                echo "No permission to read status"
                        fi
                else
                        echo "Hibabejelento is not running (No lock file)"
                fi
        ;;
        botstart)
                echo "Starting bots: ElisaBot Hibabejelento"
                /bin/bamessenger/elisabot/ElisaBot
                /bin/bamessenger/hibabej/Hibabejelento
        ;;
        botstop)
                echo "Stopping Bots: ElisaBot Hibabejelento"
                PID=$(cat /bin/bamessenger/elisabot/bame.lock)
                kill $PID
                PID=$(cat /bin/bamessenger/hibabej/bamh.lock)
                kill $PID
        ;;
        *)
                echo "ERROR invalid command"
                echo "Possible commands: start , stop , status , botstart , botstop"
                exit 1
        ;;
esac
