//TimerClass
#include "TimerClass.h"

static unsigned TimerCnt=1;

TimerClass::TimerClass(HWND hWnd,unsigned milisec):
Enabled(this, &TimerClass::GetEnabled, &TimerClass::SetEnabled, &TimerClass::GetRefEnabled){
	ID=SetTimer(hWnd,TimerCnt,milisec,NULL);
	if(!ID){
		MessageBox(hWnd, TEXT("ERROR: Timer failed"), TEXT("TimerClass::TimerClass"), MB_APPLMODAL | MB_ICONSTOP);
		return;
	}
	OwnerHwnd=hWnd;
	TimerCnt++;
	Ellapse=milisec;
	EnabledState=true;
}

TimerClass::~TimerClass(){
	KillTimer (OwnerHwnd,ID);
}

void TimerClass::Set(unsigned milisec){
	SetTimer(OwnerHwnd,ID,milisec,NULL);
	Ellapse=milisec;
	EnabledState=true;
}

void TimerClass::SetEnabled(const bool & en){
	EnabledState=en;
	if(en){
		ID=SetTimer(OwnerHwnd,ID,Ellapse,NULL);
    }else{
		KillTimer (OwnerHwnd,ID);
	}
}

const bool & TimerClass::GetEnabled() const{
    return EnabledState;
}

bool & TimerClass::GetRefEnabled() {
    return EnabledState;
}
