#!/bin/sh
#System V init script for:
#Dyndns update service (dyndns.hu)
#Created by Andras Bognar 2014

. /lib/lsb/init-functions

case $1 in
	start)
		echo "Starting Dyndns updater"
		exec /bin/bamessenger/dynd/dyndnsd
	;;
	stop)
		echo "Stopping Dyndns updater"
		PID=$(cat /bin/bamessenger/dynd/dynd.lock)
		kill $PID
	;;
	restart)
		echo "Restarting Dyndns updater"
		PID=$(cat /bin/bamessenger/dynd/dynd.lock)
		kill -HUP $PID
	;;
	status)
		echo "Status of Dyndns updater:"
		if [ -f /bin/bamessenger/dynd/dynd.lock ]; then
			PID=$(cat /bin/bamessenger/dynd/dynd.lock)
			if ! kill -0 $PID > /dev/null 2>&1; then
				echo "Dyndns updater is not running"
			else
				echo "Dyndns updater is RUNNING, PID="$PID
			fi
		else
			echo "Dyndns updater is not running"
		fi
	;;
	*)
		echo "ERROR invalid command"
		exit 1
	;;
esac 
