//generate, code, and decode user list file server database
//generate encription data source files skey.h, skey.h
#include <stdio.h>
#include <conio.h>
#include <vector>
#include <windows.h>
#include "..\keygen.h"
#include "..\skey.h"
#include "..\hl_md5.h"
#include "..\bmp.h"

using namespace std;

#define USERLIST "CL.dat"

struct User{
	char name[21];
	unsigned char PW[16];	//MD5 hash
	int ID;
	unsigned char* photo;
	vector<int> Plist;
	//Client* c;
	//statistic
	//unsigned int UstatConn;
	//unsigned int UstatSent;
	//unsigned int SumErrors;
};

vector<User*> Users;			//All registered users

//convert MD5 code from integer array to string
void MD5_IntToStr(unsigned char* m, char* s){
	int x;
	int w;
	for(x=0;x<16;x++){
		for(w=0;w<2;w++){
			switch( w? m[x]&0x0F : (m[x]&0xF0)>>4 ){
				case 0:
					s[x*2+w]='0';
					break;
				case 1:
					s[x*2+w]='1';
					break;
				case 2:
					s[x*2+w]='2';
					break;
				case 3:
					s[x*2+w]='3';
					break;
				case 4:
					s[x*2+w]='4';
					break;
				case 5:
					s[x*2+w]='5';
					break;
				case 6:
					s[x*2+w]='6';
					break;
				case 7:
					s[x*2+w]='7';
					break;
				case 8:
					s[x*2+w]='8';
					break;
				case 9:
					s[x*2+w]='9';
					break;
				case 10:
					s[x*2+w]='A';
					break;
				case 11:
					s[x*2+w]='B';
					break;
				case 12:
					s[x*2+w]='C';
					break;
				case 13:
					s[x*2+w]='D';
					break;
				case 14:
					s[x*2+w]='E';
					break;
				case 15:
					s[x*2+w]='F';
					break;
			}
		}
	}
	s[32]=0;
}

//convert MD5 code from string to integer array
void MD5_StrToInt(char* s, unsigned char* m){
	int x;
	int w;
	for(x=0;x<16;x++){
		m[x]=0;
		for(w=0;w<2;w++){
			switch( s[x*2+w] ){
				case '0':
					break;
				case '1':
					m[x]|=!w?0x10:0x01;
					break;
				case '2':
					m[x]|=!w?0x20:0x02;
					break;
				case '3':
					m[x]|=!w?0x30:0x03;
					break;
				case '4':
					m[x]|=!w?0x40:0x04;
					break;
				case '5':
					m[x]|=!w?0x50:0x05;
					break;
				case '6':
					m[x]|=!w?0x60:0x06;
					break;
				case '7':
					m[x]|=!w?0x70:0x07;
					break;
				case '8':
					m[x]|=!w?0x80:0x08;
					break;
				case '9':
					m[x]|=!w?0x90:0x09;
					break;
				case 'A':
					m[x]|=!w?0xA0:0x0A;
					break;
				case 'B':
					m[x]|=!w?0xB0:0x0B;
					break;
				case 'C':
					m[x]|=!w?0xC0:0x0C;
					break;
				case 'D':
					m[x]|=!w?0xD0:0x0D;
					break;
				case 'E':
					m[x]|=!w?0xE0:0x0E;
					break;
				case 'F':
					m[x]|=!w?0xF0:0x0F;
					break;
			}
		}
	}
}

int GetULcryToBuf(unsigned char* buf, int len, int& KEY, FILE*f){
	int x;
	for(x=0;x<len;x++){
		if(feof(f))
			return 1;
		buf[x]=fgetc(f);
	}
	Encrypt(SERVER_SCRIPT_KEY, KEY, buf, len);
	return 0;
}

void FlushBufToULcry(unsigned char* buf, int len, int& KEY, FILE*f){
	int x;
	Crypt(SERVER_SCRIPT_KEY, KEY, buf, len);
	for(x=0;x<len;x++){
		fputc(buf[x],f);
	}
}

int LoadUserList(){
	int x;
	FILE* f;
	int KEY=0;
	int NUM;
	unsigned char buf[30];
	unsigned char PASSMD5[16];
	unsigned char PASSMD5_scry[16]={0xAB,0xEB,0xC3,0x7A,0x91,0xAF,0x4E,0x12,0x82,0xE4,0x22,0x5A,0xF2,0xC7,0xB9,0xE9};
	unsigned char UID[3];
	int PID;
	f=fopen(USERLIST,"rb");
	if(f==NULL){
		printf("User list is not accessible\n");
		return 1;
	}
	
	if(GetULcryToBuf(buf,9,KEY,f)){
		fclose(f);
		return 2;
	}
	
	if(buf[8]){
		fclose(f);
		return 3;
	}
	if(strcmp((char*)buf,"USERLIST")){
		fclose(f);
		return 4;
	}
	
	User*u;
	while(!feof(f)){
		if(GetULcryToBuf(buf,21,KEY,f)){
			fclose(f);
			return 0;		//!!! itt tr vissza nem a fggvny vgn!
		}
		if(GetULcryToBuf(PASSMD5,16,KEY,f)){
			fclose(f);
			return 6;
		}
		if(GetULcryToBuf(UID,2,KEY,f)){
			fclose(f);
			return 7;
		}
		u= new User();
		buf[20]=0;
		memcpy(u->name,buf,21);
		memcpy(u->PW,PASSMD5,16);
		//crypt PW
		for(x=0;x<16;x++)
			PASSMD5[x]=PASSMD5[x]^PASSMD5_scry[x];
		
		u->ID=UID[0]*256+UID[1];
		u->photo=new unsigned char[3750];
		Users.push_back(u);
		
		printf("User Added: %s, ID=%d, PW=",u->name,u->ID);
		MD5_IntToStr(PASSMD5,(char*)buf);
		printf("%s\n",buf);
		
		if(GetULcryToBuf(u->photo,3750,KEY,f)){
			memset(u->photo,0,3750);
			fclose(f);
			return 8;
		}
		//Plist
		if(GetULcryToBuf(UID,2,KEY,f)){
			fclose(f);
			return 9;
		}
		NUM=UID[0]*256+UID[1];
		for(x=0;x<NUM;x++){
			if(GetULcryToBuf(UID,2,KEY,f)){
				fclose(f);
				return 10;
			}
			PID=UID[0]*256+UID[1];
			if(PID!=u->ID)
				u->Plist.push_back(PID);
		}
		if(feof(f))
			break;
	}
	
	fclose(f);
	return 0;
}

int SaveUserList(){
	unsigned char* buf;
	FILE*f;
	int KEY=0;
	int x,y;
	int size;
	
	f=fopen(USERLIST,"wb");
	if(f==NULL){
		printf("FATAL: User list is not accessible\n");
		return 1;
	}
	buf=new unsigned char[3750];
	
	strcpy((char*)buf,"USERLIST");
	FlushBufToULcry(buf,9,KEY,f);
	for(x=0;x<Users.size();x++){
		Users[x]->name[20]=0;
		for(y=strlen(Users[x]->name);y<21;y++)
			Users[x]->name[y]=0;
		for(y=0;y<21;y++)
			buf[y]=Users[x]->name[y];
		FlushBufToULcry(buf,21,KEY,f);
		for(y=0;y<21;y++)
			buf[y]=Users[x]->PW[y];
		FlushBufToULcry(buf,16,KEY,f);
		buf[0]=(Users[x]->ID&0xFF00)>>8;
		buf[1]=Users[x]->ID&0xFF;
		FlushBufToULcry(buf,2,KEY,f);
		for(y=0;y<3750;y++)
			buf[y]=Users[x]->photo[y];
		FlushBufToULcry(buf,3750,KEY,f);
		size=Users[x]->Plist.size();
		buf[0]=(size&0xFF00)>>8;
		buf[1]=size&0xFF;
		FlushBufToULcry(buf,2,KEY,f);
		for(y=0;y<size;y++){
			buf[0]=(Users[x]->Plist[y]&0xFF00)>>8;
			buf[1]=Users[x]->Plist[y]&0xFF;
			FlushBufToULcry(buf,2,KEY,f);
		}
	}
	delete[] buf;
	
	fclose(f);
	return 0;
}

//process partner info loaded from server
void ProcessPartner(int id, unsigned char* photo){
	int x;
	char BMPfile[100];
	sprintf(BMPfile,"%d",id);
	strcat(BMPfile,"_photo.bmp");

	//Decode photo data
	BYTE*B=new BYTE[7500];
	int z=0;
	for(x=0;x<3750;x+=3){
		B[z++]=photo[x]&0xF0;
		B[z++]=(photo[x]&0x0F)<<4;
		B[z++]=photo[x+1]&0xF0;
		B[z++]=(photo[x+1]&0x0F)<<4;
		B[z++]=photo[x+2]&0xF0;
		B[z++]=(photo[x+2]&0x0F)<<4;
	}

	long s2;
	BYTE* c = ConvertRGBToBMPBuffer ( B, 50, 50, &s2 );
	if(!c){
		printf("ERROR: ConvertRGBToBMPBuffer failed\n");
		delete[] B;
		return;
	}
	if(!SaveBMP ( c, 50, 50, s2, BMPfile )){
		printf("BMP file could not be written\n");
	}

	delete[] B;
	delete[] c;
}

unsigned char* LoadPhoto(char* fname){
	int x, y;
	long s;
	BYTE* a = LoadBMP ( &x, &y, &s, fname );
	if(!a){
		printf("ERROR: LoadBMP failed\n");
		return NULL;
	}
	if((x!=50)||(y!=50)){
		printf("ERROR: BMP size must be 50X50 !\n");
		delete[] a;
		return NULL;
	}
	BYTE* b = ConvertBMPToRGBBuffer ( a, x, y );
	if(!b){
		printf("ERROR: ConvertBMPToRGBBuffer failed\n");
		delete[] a;
		return NULL;
	}
	unsigned char* ph=new unsigned char[3750];
	int p=0;
	
	unsigned int t1,t2;
	
	for(x=0;x<3750;x++){
		t1=b[p++]&0xF0;
		t2=(b[p++]&0xF0)>>4;
		ph[x]=t1|t2;
	}
	delete[] a;
	delete[] b;
	return ph;
}


int main(int argc, char* argv[]){
	int exp_imp;
	if(argc>=2){
		if(!strcmp(argv[1],"import")){
			printf("IMPORTING...\n");
			exp_imp=2;
		}else if(!strcmp(argv[1],"export")){
			printf("EXPORTING...\n");
			exp_imp=1;
		}else{
			printf("INVALID ARGUMENT! 'export' or 'import' must be\n");
			return 0;
		}
	}else{
		printf("INVALID ARGUMENT! 'export' or 'import' must be\n");
		return 0;
	}
	int x,y;
	char str[256];
	
  //EXPORT
  if(exp_imp==1){
	if(x=LoadUserList()){
		printf("Invalid user list %d\n",x);
		return 0;
	}
	FILE*f;
	f=fopen("CLexport.txt","w");
	if(f){
		for(x=0;x<Users.size();x++){
			fprintf(f,"**********************************\n");
			Users[x]->name[20]=0;
			fprintf(f,"%s\n",Users[x]->name);
			MD5_IntToStr(Users[x]->PW, str);
			fprintf(f,"%s\n%d\n",str,Users[x]->ID);
			ProcessPartner(Users[x]->ID,Users[x]->photo);
			if(Users[x]->Plist.size()==0){
				fprintf(f,"NONE");
			}else{
				for(y=0;y<Users[x]->Plist.size();y++){
					fprintf(f,"%d,",Users[x]->Plist[y]);
				}
			}
			fprintf(f,"\n");
		}
		fclose(f);
	}else{
		printf("File open error\n");
	}
  }

  //IMPORT
  if(exp_imp==2){
	FILE*f;
	FILE*g;
	User* u=NULL;
	int s=0;
	char* c;
	f=fopen("CLexport.txt","r");
	if(f){
		while(1){
			fgets ( str, 256, f );
			if(feof(f))break;
			x=strlen(str);
			if((x>=1)&&(str[x-1]==10))str[x-1]=0;
			switch(s){
				case 0:
					u= new User();
					s++;
					break;
				//name
				case 1:
					str[20]=0;
					strcpy(u->name,str);
					s++;
					break;
				//passw
				case 2:
					MD5_StrToInt(str, u->PW);
					s++;
					break;
				//id and photo
				case 3:
					sscanf(str,"%d",&(u->ID));
					s++;
					//photo
					strcat(str,"_photo.bmp");
					u->photo=LoadPhoto(str);
					if(u->photo==NULL){
						printf("File not found: %s, process aborted",str);
						return 0;
					}
					break;
				//friends
				case 4:
					if(str[0]!='N'){
						while(c=strstr(str,",")){
							*c=0;
							sscanf(str,"%d",&y);
							u->Plist.push_back(y);
							x=0;c++;
							while(*c){
								str[x++]=*c++;
							};
							str[x]=0;
						}
					}
					s=0;
					Users.push_back(u);
					break;
			}
		}
		
		SaveUserList();
		for(x=0;x<Users.size();x++){
			if(Users[x]->photo)delete[] Users[x]->photo;
			delete Users[x];
		}
		fclose(f);
	}else{
		printf("File open error\n");
	}
  }

	return 0;
}
